use std::future;
use std::sync::Arc;
use serde::Deserialize;
use serde_json::{json, Value};
use tower_lsp::jsonrpc::Result;
use tower_lsp::lsp_types::*;

use crate::core::fast_hdlparam::FastHdlparam;
use crate::server::Backend;

#[derive(Debug, Deserialize)]
pub struct CustomRequestParams {
    // 定义你需要的参数
    pub data: Value,
}


#[derive(Debug, Deserialize)]
pub struct CustomResponse {
    result: serde_json::Value
}

#[derive(Clone)]
pub struct CustomRequest;

impl <'a>tower_lsp::jsonrpc::Method<&'a Arc<Backend>, (), Result<i32>> for CustomRequest {
    type Future = future::Ready<Result<i32>>;

    fn invoke(&self, _server: &'a Arc<Backend>, _params: ()) -> Self::Future {
        future::ready(custom_request())
    }
}

pub fn custom_request() -> Result<i32> {
    // let command = params[0].clone();
    // let message = String::from("receive command: ") + &command;

    // let response = CustomResponse {
    //     result: serde_json::Value::String(message),
    // };

    Ok(123)
}

#[derive(Clone)]
pub struct DoFastApi;

impl <'a>tower_lsp::jsonrpc::Method<&'a Arc<Backend>, (), Result<FastHdlparam>> for CustomRequest {
    type Future = future::Ready<Result<FastHdlparam>>;

    fn invoke(&self, _server: &'a Arc<Backend>, _params: ()) -> Self::Future {
        future::ready(do_fast())
    }
}

pub fn do_fast() -> Result<FastHdlparam> {

}